--------------------------------------
-- King of the Hill Script by mat5b --
--------------------------------------
function hudtxt(id,color,text,x,y,align)
	parse("hudtxt "..id.." \""..color..text.."\" "..x.." "..y.." "..align)
end
function clearhudtxt(id)
	parse("hudtxt "..id.." \"\" 0 0 0")
end
function array(m)
	local array = {}
	for i = 1, m do
		array[i] = 0
	end
	return array
end
function sv_sound3(snd,team)
	for id=1,32 do
		if (player(id,"team")==team) then
			parse('sv_sound2 '..id..' '..snd..'')
		end
	end
end
function sv_msg3(msg,team)
	for id=1,32 do
		if player(id,"team")==team then
			parse('sv_msg2 '..id..' '..msg..'')
		end
	end
end

koth={}
teams={"Terrorists","Counter-terrorists"}
kothcapprog=0
kothtimer1sec=0
kothtimer2sec=0
kothtimer1min=3
kothtimer2min=3
won=0
kothzero1=0
kothzero2=0
kothpoint=0
image("gfx/tf2/controlpoint_small.png",300,450,2)
kothimg=image("gfx/tf2/koth_small.png",300,30,2)
capper=array(32)
capx=array(32)
capy=array(32)
capped=array(32)

addhook("second","koth.hud")
addhook("startround","koth.resetthings")
addhook("dominate","koth.dominate")
addhook("endround","koth.winsounds")
addhook("ms100","koth.always")

function koth.hud()
	for i=1,32 do
		if player(i,"exists") then
			hudtxt(12,"255255255",""..kothtimer1min..":"..kothzero1..""..kothtimer1sec.."",335,23,1)
			hudtxt(13,"255255255",""..kothtimer2min..":"..kothzero2..""..kothtimer2sec.."",245,23,1)
		end
	end
end

function koth.dominate(id,team,x,y)
	if team==1 then
		parse('effect "flare" '..player(id,'x')..' '..player(id,'y')..' 15 50 200 0 0') 
		if kothpoint==0 then
			if capped[id]==0 then
				kothcapteam=1
				capper[id]=1
				capx[id]=x
				capy[id]=y
			elseif capped[id]==1 then
				if kothteam==2 then
					freehook("second","koth.kothtimer2")
				end
				addhook("second","koth.kothtimer1")
				kothteam=1
				kothcapprog=0
				for i=1,32 do
					if player(i,"exists") then
						capper[i]=0
						capx[i]=0
						capy[i]=0
						capped[i]=0
					end
				end
				capped[id]=0
				clearhudtxt(11)
				image("gfx/tf2/controlpoint_red_small.png",300,450,2)
				return 0
			end
		end
		return 1
	elseif team==2 then
		parse('effect "flare" '..player(id,'x')..' '..player(id,'y')..' 15 50 0 0 200') 
		if kothpoint==0 then
			if capped[id]==0 then
				kothcapteam=2
				capper[id]=1
				capx[id]=x
				capy[id]=y
			end
			if capped[id]==1 then
				if kothteam==1 then
					freehook("second","koth.kothtimer1")
				end
				addhook("second","koth.kothtimer2")
				kothteam=2
				kothcapprog=0
				for i=1,32 do
					if player(i,"exists") then
						capper[i]=0
						capx[i]=0
						capy[i]=0
						capped[i]=0
					end
				end
				capped[id]=0
				clearhudtxt(11)
				image("gfx/tf2/controlpoint_blu_small.png",300,450,2)
				return 0
			end
		end
		return 1
	end
end

function koth.always()
	local d=kothcapprog
	local f=0
	local e=0
	for id=1,32 do
		if player(id,"exists") and player(id,"health")>0 then
			if capper[id]==1 and kothcapteam==player(id,"team") then
				dec=0
				if (player(id,"tilex")==capx[id]) and (player(id,"tiley")==capy[id]) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]-1) and (player(id,"tiley")==capy[id]-1) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]) and (player(id,"tiley")==capy[id]-1) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]-1) and (player(id,"tiley")==capy[id]) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]-1) and (player(id,"tiley")==capy[id]+1) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]+1) and (player(id,"tiley")==capy[id]-1) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]+1) and (player(id,"tiley")==capy[id]+1) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]) and (player(id,"tiley")==capy[id]+1) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				elseif (player(id,"tilex")==capx[id]+1) and (player(id,"tiley")==capy[id]) then
					kothcapprog=kothcapprog+1
					hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[player(id,"team")].."",300,450,1)
					f=1
				else
					capper[id]=0
					capx[id]=0
					capy[id]=0
					kothcapteam=player(id,"team")
				end
			end
			if kothcapprog>=100 then
				clearhudtxt(11)
				hudtxt(11,"255255255","Point almost captured! Get on the flag again!",300,450,1)
				capped[id]=1
				e=1
			end
		end
	end
	if f==0 then 
		dec=1
	end
	if d==kothcapprog and d~=0 and kothcapprog~=0 and kothcapteam~=0 then
		dec=1
	end
	if e==1 then
		dec=0
	end
	if dec==1 then
		if kothcapprog>0 then
			kothcapprog=kothcapprog-1
			hudtxt(11,"255255255",""..kothcapprog.."%/100% capped by "..teams[kothcapteam].."",300,450,1)
		end
		if kothcapprog<=0 then
			dec=0
			kothcapprog=0
			kothcapteam=0
			clearhudtxt(11)
		end
	end
end

function koth.kothtimer1()
	if kothteam==1 then
		if kothtimer1min>=0 then
			kothtimer1sec=kothtimer1sec-1
		end
		if kothtimer1sec<=-1 then
			if kothtimer1min>=1 then
				kothtimer1min=kothtimer1min-1
				kothtimer1sec=59
			else
				kothtimer1min=0
				kothtimer1sec=0
			end
		end
		if kothtimer1sec>=10 then
			kothzero1=""
		else
			kothzero1=0
		end
		if kothtimer1min==0 and kothtimer1sec==0 then
			if won==0 then
				won=1
			end
			parse('trigger twin')
			humiliate(2)
		end
	end
end
function koth.kothtimer2()
	if kothteam==2 then
		if kothtimer2min>=0 then
			kothtimer2sec=kothtimer2sec-1
		end
		if kothtimer2sec<=-1 then
			if kothtimer2min>=1 then
				kothtimer2min=kothtimer2min-1
				kothtimer2sec=59
			else
				kothtimer2min=0
				kothtimer2sec=0
			end
		end
		if kothtimer2sec>=10 then
			kothzero2=""
		else
			kothzero2=0
		end
		if kothtimer2min==0 and kothtimer2sec==0 then
			if won==0 then
				won=1
			end
			parse('trigger ctwin')
			humiliate(1)
		end
	end
end

function koth.winsounds(i)
	if i==1 or i==50 or i==40 then
		sv_msg3("255255255VICTORY!",1)
		sv_msg3("255255255YOU FAILED!",2)
		sv_sound3("your_team_won.ogg",1)
		sv_sound3("your_team_lost.ogg",2)
		humiliate(2)
	elseif i==2 or i==51 or i==41 then
		sv_msg3("255255255VICTORY!",2)
		sv_msg3("255255255YOU FAILED!",1)
		sv_sound3("your_team_won.ogg",2)
		sv_sound3("your_team_lost.ogg",1)
		humiliate(1)
	end
end

function koth.resetthings(mode)
	kothpoint=0
	kothtimer1sec=0
	kothtimer2sec=0
	kothtimer1min=3
	kothtimer2min=3
	kothteam=0
	image("gfx/tf2/controlpoint_small.png",300,450,2)
	won=0
	kothzero1=0
	kothzero2=0
	kothimg=image("gfx/tf2/koth_small.png",300,30,2)
	for id=1,32 do
		capper[id]=0
		capx[id]=0
		capy[id]=0
		capped[id]=0
		parse("speedmod "..id.." 0")
	end
	clearhudtxt(11)
	kothcapprog=0
end

function humiliate(team)
	for id=1,32 do
		if player(id,"exists") and player(id,"health")>0 then
			if player(id,"team")==team then
				parse('strip '..id)
				parse('speedmod '..id..' -100')
			end
		end
	end
end